#include <math.h>

#include "sounds-cd.h"

#if defined(__GNUC__)
static char
decompose_square_data (void *junk __attribute__((__unused__)), unsigned long time,
		       short *left, short *right)
#else
static char
decompose_square_data (void *junk, unsigned long time,
		       short *left, short *right)
#endif
{
  int i, n;
  double t, y;
  short v;

  n = time/SAMPLE_RATE;
  t = (time*1./SAMPLE_RATE)*BASIC_FREQUENCY;
  t -= floor (t);
#if 1
  y = 0.;
#else
  if ( t - floor (t) < 0.5 )
    y = TWOPI/8;
  else
    y = -TWOPI/8;
  y = -y;
#endif
  for ( i=0 ; i<=n ; i++ )
    y += sin (t*TWOPI*(2*i+1)) / (2*i+1);
  v = BASIC_AMPLITUDE*y*4*SQRT2/TWOPI + 0.5;
  *left = v;
  *right = v;
  return ( time < DECOMPOSE_LENGTH*SAMPLE_RATE );
}

int
main (void)
{
  record_track (decompose_square_data, 0);
  return 0;
}
