#include <math.h>

#include "sounds-cd.h"

#if defined(__GNUC__)
static char
decompose_triangular_data (void *junk __attribute__((__unused__)), unsigned long time,
			   short *left, short *right)
#else
static char
decompose_triangular_data (void *junk, unsigned long time,
			   short *left, short *right)
#endif
{
  int i, n;
  double t, y;
  short v;

  n = time/SAMPLE_RATE;
  t = (time*1./SAMPLE_RATE)*BASIC_FREQUENCY;
  t -= floor (t);
#if 1
  y = 0.;
#else
  if ( t < 0.25 )
    y = t*TWOPI*TWOPI/8;
  else if ( t < 0.75 )
    y = (0.5-t)*TWOPI*TWOPI/8;
  else
    y = (t-1)*TWOPI*TWOPI/8;
  y = -y;
#endif
  for ( i=0 ; i<=n ; i++ )
    {
      if ( i&1 )
	y -= sin (t*TWOPI*(2*i+1)) / ((2*i+1)*(2*i+1));
      else
	y += sin (t*TWOPI*(2*i+1)) / ((2*i+1)*(2*i+1));
    }
  v = BASIC_AMPLITUDE*y*16*SQRT2*SQRT3/TWOPI/TWOPI + 0.5;
  *left = v;
  *right = v;
  return ( time < DECOMPOSE_LENGTH*SAMPLE_RATE );
}

int
main (void)
{
  record_track (decompose_triangular_data, 0);
  return 0;
}
