#include <math.h>

#include "sounds-cd.h"

#if defined(__GNUC__)
static char
pure_square_data (void *junk __attribute__((__unused__)), unsigned long time,
		  short *left, short *right)
#else
static char
pure_square_data (void *junk, unsigned long time,
		  short *left, short *right)
#endif
{
  double t;
  short v;

  t = (time*1./SAMPLE_RATE)*BASIC_FREQUENCY;
  if ( t - floor (t) < 0.5 )
    v = BASIC_AMPLITUDE/SQRT2;
  else
    v = -BASIC_AMPLITUDE/SQRT2;
  *left = v;
  *right = v;
  return ( time < BASIC_LENGTH*SAMPLE_RATE );
}

int
main (void)
{
  record_track (pure_square_data, 0);
  return 0;
}
