#include <math.h>

#include "sounds-cd.h"

#if defined(__GNUC__)
static char
pure_triangular_data (void *junk __attribute__((__unused__)), unsigned long time,
		      short *left, short *right)
#else
static char
pure_triangular_data (void *junk, unsigned long time,
		  short *left, short *right)
#endif
{
  double t;
  short v;

  t = (time*1./SAMPLE_RATE)*BASIC_FREQUENCY;
  t -= floor(t);
  if ( t < 0.25 )
    v = t*BASIC_AMPLITUDE*2*SQRT2*SQRT3;
  else if ( t < 0.75 )
    v = (0.5-t)*BASIC_AMPLITUDE*2*SQRT2*SQRT3;
  else
    v = (t-1)*BASIC_AMPLITUDE*2*SQRT2*SQRT3;
  *left = v;
  *right = v;
  return ( time < BASIC_LENGTH*SAMPLE_RATE );
}

int
main (void)
{
  record_track (pure_triangular_data, 0);
  return 0;
}
