#include <math.h>

#include "sounds-cd.h"

#if defined(__GNUC__)
static char
sqrt2_beat_data (void *junk __attribute__((__unused__)), unsigned long time,
		  short *left, short *right)
#else
static char
sqrt2_beat_data (void *junk, unsigned long time,
		  short *left, short *right)
#endif
{
  double t, t2, y;
  short v;

  t = time*1./SAMPLE_RATE;
  t2 = t*SQRT2;
  t -= floor (t);
  t2 -= floor (t2);
  y = 0.;
  if ( t<0.1 )
    y += sin (t*BASIC_FREQUENCY*TWOPI);
  if ( t2<0.1 )
    y += sin (t2*BASIC_FREQUENCY*TWOPI);
  v = y*BASIC_AMPLITUDE + .5;
  *left = v;
  *right = v;
  return ( time < 55*SAMPLE_RATE );
}

int
main (void)
{
  record_track (sqrt2_beat_data, 0);
  return 0;
}
